package org.xdoclet.plugin.weblogic.qtags;

public class WeblogicPersistenceTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.weblogic.qtags.WeblogicPersistenceTag {
    public static final String NAME = "weblogic.persistence";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"is-modified-method-name",
		"delay-updates-until-end-of-tx",
		"finders-load-bean",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public WeblogicPersistenceTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public WeblogicPersistenceTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public boolean getIsModifiedMethodName() {
		boolean required = false;
        String result = getNamedParameter("is-modified-method-name");
        if(required && result == null) {
            bomb("is-modified-method-name=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean getDelayUpdatesUntilEndOfTx() {
		boolean required = false;
        String result = getNamedParameter("delay-updates-until-end-of-tx");
        if(required && result == null) {
            bomb("delay-updates-until-end-of-tx=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean getFindersLoadBean() {
		boolean required = false;
        String result = getNamedParameter("finders-load-bean");
        if(required && result == null) {
            bomb("finders-load-bean=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getIsModifiedMethodName();
        getDelayUpdatesUntilEndOfTx();
        getFindersLoadBean();
    }

    public void validateModel() {
        // check uniqueness
        if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}