package org.xdoclet.plugin.weblogic.qtags;

public class WeblogicPoolTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.weblogic.qtags.WeblogicPoolTag {
    public static final String NAME = "weblogic.pool";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"max-beans-in-free-pool",
		"initial-beans-in-free-pool",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public WeblogicPoolTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public WeblogicPoolTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.Integer getMaxBeansInFreePool() {
		boolean required = false;
        String result = getNamedParameter("max-beans-in-free-pool");
        if(required && result == null) {
            bomb("max-beans-in-free-pool=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("max-beans-in-free-pool=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public java.lang.Integer getInitialBeansInFreePool() {
		boolean required = false;
        String result = getNamedParameter("initial-beans-in-free-pool");
        if(required && result == null) {
            bomb("initial-beans-in-free-pool=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("initial-beans-in-free-pool=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getMaxBeansInFreePool();
        getInitialBeansInFreePool();
    }

    public void validateModel() {
        // check uniqueness
        if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}